--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: THREAD DETACHER
-- @author   	Valentin Schmidt
-- @version  	0.1
--****************************************************************************

property ancestor
property _queue
property _instance

----------------------------------------
-- @constructor (explicitely forced singleton class)
----------------------------------------
on new (me)
	if not voidP(me.script._instance) then return me.script._instance
	me.ancestor = timeout().new("_detachtimer_", 0, #_call, me)
	me._queue = []
	me.script._instance = me
	return me
end

----------------------------------------
-- The only public method
-- @param {symbol} cbHandler
-- @param {object} [cbTarget=_movie]
-- @param {any} [args]
----------------------------------------
on detach (me, cbHandler, cbTarget, args1, args2)
	if voidP(cbTarget) then cbTarget = _movie
	me._queue.add([cbHandler, cbTarget, args1, args2])
	me.period = 1
end

----------------------------------------
-- Called by timeout
-- @callback
----------------------------------------
on _call (me)
	me.period = 0
	q = me._queue.duplicate()
	me._queue = []
	repeat with t in q
		call(t[1], t[2], t[3], t[4])
	end repeat
end

----------------------------------------
-- Destructor called by LSW
-- @callback
----------------------------------------
on __destruct (me)
	me.forget()
	me.script._instance = void
end
