--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #MessageBox
  me.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
	obj._class = #MessageBox
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addButton (string|int PushButtonID, int role)
on addButton (me,p1,p2)
	if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#addButton,p1,p2)
end

-- setDefaultButton (int)
on setDefaultButton (me,p1)
  $.Qt._qx.callWidget(me._id,#setDefaultButton,p1)
end

-- setDetailedText (string)
on setDetailedText (me,p1)
  $.Qt._qx.callWidget(me._id,#setDetailedText,p1)
end

-- setIcon (int)
on setIcon (me,p1)
  $.Qt._qx.callWidget(me._id,#setIcon,p1)
end

-- setStandardButtons (int)
on setStandardButtons (me,p1)
  $.Qt._qx.callWidget(me._id,#setStandardButtons,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- setTextFormat (int)
on setTextFormat (me,p1)
  $.Qt._qx.callWidget(me._id,#setTextFormat,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

-- about (WidgetID,string,string)
on about (scr,p1,p2,p3)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(#MessageBox,#about,p1,p2,p3)
end

-- aboutQt (WidgetID,*string)
on aboutQt (scr,p1,p2)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(#MessageBox,#aboutQt,p1,p2)
end

-- critical (WidgetID,string,string,*int,int) -> int
on critical (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#MessageBox,#critical,p1,p2,p3,p4,p5)
end

-- information (WidgetID,string,string,*int,int) -> int
on information (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#MessageBox,#information,p1,p2,p3,p4,p5)
end

-- question (WidgetID,string,string,*int,int) -> int
on question (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#MessageBox,#question,p1,p2,p3,p4,p5)
end

-- warning (WidgetID,string,string,*int,int) -> int
on warning (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#MessageBox,#warning,p1,p2,p3,p4,p5)
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- accepted
on accepted(me,id)
  me._detach(#accepted,id)
end

-- finished -> int
on finished(me,id,p1)
  me._detach(#finished,id,p1)
end

-- rejected
on rejected(me,id)
  me._detach(#rejected,id)
end

