--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
  me._class = #Clipboard
  -- implement interface
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Clipboard
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- clear ()
on clear (me)
  $.Qt._qx.callObject(me._id,#clear)
end

-- formats () -> list
on formats (me)
  return $.Qt._qx.callObject(me._id,#formats)
end

-- getImage () -> ImageID
on getImage (me)
  obj = $.Qt.Image._make($.Qt._qx.callObject(me._id,#getImage))
  me._children.add(obj)
  return obj
end

-- getMimeData (string) -> bytearray|string
on getMimeData (me,p1)
  return $.Qt._qx.callObject(me._id,#getMimeData,p1)
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- setImage (ImageID|image|string)
on setImage (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#setImage,p1)
end

-- setMimeData (string,bytearray|string)
on setMimeData (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setMimeData,p1,p2)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callObject(me._id,#setText,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callObject(me._id,#text)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- dataChanged
on dataChanged(me,id)
  me._detach(#dataChanged,id)
end

