--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()+(unused,image)+(unused,int,int,*int)
on new (me,p1,p2,p3)
  me._class = #Image
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  
  pc = the paramCount
  case (pc) of
  	1: me._id = $.Qt._qx.newObject(me._class)
  	2: me._id = $.Qt._qx.newObject(me._class, VOID, p1)
  	3: me._id = $.Qt._qx.newObject(me._class, VOID, p1,p2)
  	4: me._id = $.Qt._qx.newObject(me._class, VOID, p1,p2,p3)
  end case
  	
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Image
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- grabWidget (WidgetID) -> bool
on grabWidget (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callObject(me._id,#grabWidget,p1)
end

-- grabWindow (*int) -> bool
on grabWindow (me,p1)
  return $.Qt._qx.callObject(me._id,#grabWindow,p1)
end

-- height () -> int
on height (me)
  return $.Qt._qx.callObject(me._id,#height)
end

-- isNull () -> bool
on isNull (me)
  return $.Qt._qx.callObject(me._id,#isNull)
end

-- load (image)+(string,*int)
on load (me,p1)
  $.Qt._qx.callObject(me._id,#load,p1)
end

-- loadData (bytearray|string,*int)
on loadData (me,p1)
  $.Qt._qx.callObject(me._id,#loadData,p1)
end

-- save (*string,int) -> bool|image
on save (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#save,p1,p2)
end

-- saveData (*int)
on saveData (me,p1)
  $.Qt._qx.callObject(me._id,#saveData,p1)
end

-- width () -> int
on width (me)
  return $.Qt._qx.callObject(me._id,#width)
end

----------------------------------------
-- STATIC
----------------------------------------

-- grabWidget (int) -> image
--on grabWidget (scr,p1)
--	if ilk(p1)=#instance then p1 = p1._id
--  return $.Qt._qx.callObject(#Image,#grabWidget,p1)
--end

---- grabWindow (*int) -> bool
--on grabWindow (scr,p1)
--  return $.Qt._qx.callObject(#Image,#grabWindow,p1)
--end

----------------------------------------
-- SIGNALS
----------------------------------------

