--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #TreeWidgetItem
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #TreeWidgetItem
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addChild (TreeWidgetItemID)
on addChild (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#addChild,p1)
end

-- addChildren (TreeWidgetItemIDs)
on addChildren (me,p1)
  $.Qt._qx.callObject(me._id,#addChildren,p1)
end

-- child (int) -> TreeWidgetItemID
on child (me,p1)
  obj = $.Qt.TreeWidgetItem._make($.Qt._qx.callObject(me._id,#child,p1))
  me._children.add(obj)
  return obj
end

-- childCount () -> int
on childCount (me)
  return $.Qt._qx.callObject(me._id,#childCount)
end

-- columnCount () -> int
on columnCount (me)
  return $.Qt._qx.callObject(me._id,#columnCount)
end

-- data (int,int) -> int|float|string
on data (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#data,p1,p2)
end

-- flags () -> int
on flags (me)
  return $.Qt._qx.callObject(me._id,#flags)
end

-- insertChild (int,TreeWidgetItemID)
on insertChild (me,p1,p2)
  if ilk(p2)=#instance then p2 = p2._id
  $.Qt._qx.callObject(me._id,#insertChild,p1,p2)
end

-- parent () -> TreeWidgetItemID
on parent (me)
  obj = $.Qt.TreeWidgetItem._make($.Qt._qx.callObject(me._id,#parent))
  me._children.add(obj)
  return obj
end

-- removeChild (TreeWidgetItemID)
on removeChild (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#removeChild,p1)
end

-- setData (int,int,int|float|string)
on setData (me,p1,p2,p3)
  $.Qt._qx.callObject(me._id,#setData,p1,p2,p3)
end

-- setDisabled (bool)
on setDisabled (me,p1)
  $.Qt._qx.callObject(me._id,#setDisabled,p1)
end

-- setExpanded (bool)
on setExpanded (me,p1)
  $.Qt._qx.callObject(me._id,#setExpanded,p1)
end

-- setFlags (int)
on setFlags (me,p1)
  $.Qt._qx.callObject(me._id,#setFlags,p1)
end

-- setIcon (int,image|string)
on setIcon (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setIcon,p1,p2)
end

-- setSelected (bool)
on setSelected (me,p1)
  $.Qt._qx.callObject(me._id,#setSelected,p1)
end

-- setSortValue (int,int)
on setSortValue (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setSortValue,p1,p2)
end

-- setStatusTip (int,string)
on setStatusTip (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setStatusTip,p1,p2)
end

-- setText (int,string)
on setText (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setText,p1,p2)
end

-- setToolTip (int,string)
on setToolTip (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setToolTip,p1,p2)
end

-- setWhatsThis (int,string)
on setWhatsThis (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setWhatsThis,p1,p2)
end

-- takeChildren () -> TreeWidgetItemIDs
on takeChildren (me)
  return $.Qt._qx.callObject(me._id,#takeChildren)
end

-- text (int) -> string
on text (me,p1)
  return $.Qt._qx.callObject(me._id,#text,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

