--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID,string)
on new (me,p1,p2)
  me._class = #TreeView
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1,p2)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TreeView
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- keyboardSearch ()
on keyboardSearch (me)
  $.Qt._qx.callWidget(me._id,#keyboardSearch)
end

-- reset ()
on reset (me)
  $.Qt._qx.callWidget(me._id,#reset)
end

-- scrollTo (string,*int)
on scrollTo (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#scrollTo,p1,p2)
end

-- selectAll ()
on selectAll (me)
  $.Qt._qx.callWidget(me._id,#selectAll)
end

-- setAlternatingRowColors (bool)
on setAlternatingRowColors (me,p1)
  $.Qt._qx.callWidget(me._id,#setAlternatingRowColors,p1)
end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
  $.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

-- sortByColumn (int,*int)
on sortByColumn (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#sortByColumn,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> string
on activated(me,id,p1)
  me._detach(#activated,id,p1)
end

-- clicked -> string
on clicked(me,id,p1)
  me._detach(#clicked,id,p1)
end

-- collapsed
on collapsed(me,id)
  me._detach(#collapsed,id)
end

-- doubleClicked -> string
on doubleClicked(me,id,p1)
  me._detach(#doubleClicked,id,p1)
end

-- entered -> string
on entered(me,id,p1)
  me._detach(#entered,id,p1)
end

-- expanded
on expanded(me,id)
  me._detach(#expanded,id)
end

-- pressed -> string
on pressed(me,id,p1)
  me._detach(#pressed,id,p1)
end

